#!/bin/sh
#
# MartiniB #
#
#

E2conf=/etc/enigma2/settings
Services=/etc/enigma2/lamedb

foo="$0"
crntNamePath=${foo%.*}
crntNameTXT=$crntNamePath".txt"
crntNameExt=${foo##*/}
crntNameShort=${crntNameExt%.*}
fileCmd=/tmp/"$crntNameShort".CMD
#fileLog=/tmp/"$crntNameShort".Log
fileTuneFailed=$crntNamePath".TuneFailed"
fileTuneOK=$crntNamePath".TuneOK_"`date +%y%m%d`

[ -e /etc/enigma2/settings ] && [ -e /etc/enigma2/lamedb ] || exit

[ ! -e $fileTuneFailed ] && echo -e "#\n# Tune Failed list:\n#\n"SatPos"\t"Frequency"\t"Symbolrate"\t"Transponder-ID"\t\t"Date-Time>$fileTuneFailed
[ ! -e $fileTuneOK ] && echo -e "#\n# Tune OK list:\n#\n"SatPos"\t"Frequency"\t"Symbolrate"\t"Transponder-ID"\t\t"Signal-Info>$fileTuneOK

FreePort=80
DOCMD1="wget -O $fileCmd -q http://localhost:$FreePort/web"
DOCMD2=$DOCMD1/remotecontrol?command=

# Wakeup form Standby
$DOCMD1/powerstate?newstate=4

PreviousOkServiceRef=1:0:1:1897:D:55:300000:0:0:0:
$DOCMD1/zap?sRef=$PreviousOkServiceRef
sleep 2

ZapToService () {
	$DOCMD1/zap?sRef=$ServiceRef
	Symbolrate=`echo $line| sed -e s#:#\ #g| awk {'print $3'}`
	Symbolrate=$((Symbolrate / 1000))
	if [ "$Symbolrate" -ge "20000" ]; then
		sleep 2
	elif [ "$Symbolrate" -ge "10000" ]; then
		sleep 3
	elif [ "$Symbolrate" -ge "9000" ]; then
		sleep 4
	elif [ "$Symbolrate" -ge "8000" ]; then
		sleep 5
	elif [ "$Symbolrate" -ge "7000" ]; then
		sleep 6
	elif [ "$Symbolrate" -ge "6000" ]; then
		sleep 7
	elif [ "$Symbolrate" -ge "5000" ]; then
		sleep 8
	else
		sleep 10
	fi
	$DOCMD1/signal
	sleep 1
	sed -e ':a;N;$!ba;s/\n/\ /g' -e s#[[:space:]]##g $fileCmd>$fileCmd.singleline
	SignalInfo=`grep "<e2snrdb>" $fileCmd.singleline| sed -e 's/.*<e2snrdb>//' -e 's/<.*//' -e 's/.*\/.*//' -e 's/dB/\ dB/'`
	SignalInfo2=${SignalInfo%.*}
	Freq=`echo $line| sed -e s#:#\ #g| awk {'print $2'}`
	case "$line" in
		s\ *)	Pol=" "`echo $line| sed -e s#:#\ #g| awk {'print $4'}| sed -e s#0#H# -e s#1#V#`
			Freq=`echo $((Freq / 1000))| sed -e s#[0-9][0-9]#\&\.#`$Pol;;
		*)	Pol=""
			Freq=$((Freq / 1000));;
	esac
	[ "$SignalInfo2" -ge "0" -a "$SignalInfo2" -le "9" ] && SignalInfo=" "$SignalInfo
	echo -e "$SignalInfo\t"$satPosE2"\t"$Freq"\t"$Symbolrate"\t"$TransponderID
	if [ "$SignalInfo2" -le "4" ] || [ "$SignalInfo2" -gt "25" ]; then
		echo -e $satPosE2"\t"$Freq"\t"$Symbolrate"\t\t"$TransponderID"\t"`date +%y.%m.%d.\ %H:%M:%S`>>$fileTuneFailed
		$DOCMD1/zap?sRef=$PreviousOkServiceRef
		sleep 2
	else
		echo -e $satPosE2"\t"$Freq"\t"$Symbolrate"\t\t"$TransponderID"\t"$SignalInfo>>$fileTuneOK
		PreviousOkServiceRef=$ServiceRef
	fi
	$DOCMD2"174"
	$DOCMD2"174"
#exit
}

while read line; do
  case "$line" in
	end)
		break;;
	\/)
#exit
		TransponderID="" Pol="";;
	t\ *|c\ *)
	;;
	s\ *)
	   if [ "$TransponderID" ]; then
		satPos=`echo $line| sed -e s#:#\ #g| awk {'print $6'}`
		[ "$satPos" -lt 0 ] && satPosE2=$((3600 + satPos)) || satPosE2="$satPos"
		if [ ! "$satPosE2" = "$satPosLastCheck" ]; then
			if grep -qs ".sat.$satPosE2." "$E2conf"; then
				case "$satPosE2" in
					*)
					#192)
						satPosInst=1;;
					*)
						satPosInst="skip";;
				esac
			else
				satPosInst=0
			fi
			satPosLastCheck="$satPosE2"
			echo -e satPosE2: "$satPosE2\t\t\t" satPosInst: "$satPosInst"
		fi
		if [ "$satPosInst" = "1" ]; then

# type 1 = digital television service
# type 4 = nvod reference service (NYI)
# type 17 = MPEG-2 HD digital television service
# type 22 = advanced codec SD digital television
# type 24 = advanced codec SD NVOD reference service (NYI)
# type 25 = advanced codec HD digital television
# type 27 = advanced codec HD NVOD reference service (NYI)
# type 2 = digital radio sound service
# type 10 = advanced codec digital radio sound service

			TransponderServices=`grep "^....:$TransponderID:.*:0" "$Services"`
			if [ "$TransponderServices" ]; then
				ServiceID=""
				for ServiceType in 1 25 17 22 24 27 4 25 130 133 2 *; do
					for Service in $TransponderServices; do
						case "$Service" in
							*:*:*:*:$ServiceType:0) ServiceID=`echo $Service| sed -e s#:.*##` break;;
						esac
					done
					if [ "$ServiceID" ]; then
						ServiceRef=1:0:1:"$ServiceID"`echo $TransponderID| sed -e s#........##`:`echo $TransponderID| sed -e s#:.*##`:0:0:0
						ZapToService
						break
					fi
				done
			fi
		fi
	   fi
	;;
	[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]:[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]:[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f])
		TransponderID="$line"
		if grep -qs "[[:space:]]$TransponderID[[:space:]]" "$fileTuneFailed" ||
		grep -qs "[[:space:]]$TransponderID[[:space:]]" "$fileTuneOK"; then
			TransponderID=""
		fi
	;;
  esac
done < "$Services"
